clear all;

%% CD system
system = 'CD';
k = 20;
load(system);
A = E\A;
B = E\B;

%% RC ladder circuit
% system = 'onePortRCladderCircuit40';
% k = 10;
% load(system);

%% reduction
n = size(A, 1)
%pause
tol = 1e-8;
maxIter = 200;
shift = abs(randn(k, 1));
E = eye(n);
Ek = eye(k);
%[V, W] = IRKA(E, A, B, C, shift, tol, maxIter);
[Ak,Bk,Ck] = IrkaN(A,B,C,k, tol);
s0 = 0;
freqs = 0:0.1:10;
freqs = 10.^freqs;

out_orig = TransferFunc(-A, E, B, C', s0, freqs);
size(C)
%size(V)

%lm_t = C*V;
%lm = lm_t.';

%Eh = (W'*V)\(W'*E*V);
%Ah = (W'*V)\(W'*A*V);
%Bh = (W'*V)\(W'*B);
    
out_reduced = TransferFunc(-Ak, Ek, Bk, Ck',  s0, freqs);
H_amplitude = 20*log(abs(out_orig.H));
H_amp_red = 20*log(abs(out_reduced.H));
 
figure;
semilogx(freqs, H_amplitude);
hold on;
semilogx(freqs, H_amp_red,'r');
xlabel('frequency (Hz)');
ylabel('mag (dB)');
legend('original model', ' reduced model');
figure;
semilogx(freqs, 180*angle(out_orig.H)/pi);
hold on;
semilogx(freqs, 180*angle(out_reduced.H)/pi,'r');
xlabel('frequency (Hz)');
ylabel('phase (degree)');
legend('original model', ' reduced model')    
